---
title: ReadableStreamDefaultReader.cancel()
slug: Web/API/ReadableStreamDefaultReader/cancel
tags:
  - API
  - Method
  - ReadableStreamDefaultReader
  - Reference
  - Streams
  - cancel
---
<div>{{APIRef("Streams")}}</div>

<p class="summary">The <strong><code>cancel()</code></strong> method of the {{domxref("ReadableStreamDefaultReader")}} interface cancels the stream, signaling a loss of interest in the stream by a consumer. The supplied reason argument will be given to the underlying source, which may or may not use it.</p>

<p>Cancel is used when you've completely finished with the stream and don't need any more data from it, even if there are chunks enqueued waiting to be read. That data is lost after cancel is called, and the stream is not readable any more. To read those chunks still and not completely get rid of the stream, you'd use {{domxref("ReadableStreamDefaultController.close()")}}.</p>

<div class="note"><strong>Note</strong>: If the reader is active, the <code>cancel()</code> method behaves the same as that for the associated stream ({{domxref("ReadableStream.cancel()")}}).</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>promise</em> = <em>readableStreamDefaultReader</em>.cancel(<em>reason</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>reason {{optional_inline}}</dt>
 <dd>A {{domxref("DOMString")}} providing a human-readable reason for the cancellation.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}}, which fulfills with the value given in the <code>reason</code> parameter.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>TypeError</dt>
 <dd>The source object is not a <code>ReadableStreamDefaultReader</code>, or the stream has no owner.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the following simple example, a previously-created custom <code>ReadableStream</code> is read using a {{domxref("ReadableStreamDefaultReader")}} created using <code>getReader()</code>. (this code is based on our <a href="https://mdn.github.io/dom-examples/streams/simple-random-stream/">Simple random stream example</a>). Each chunk is read sequentially and output to the UI, until the stream has finished being read, at which point we return out of the recursive function and print the entire stream to another part of the UI.</p>

<p>When the stream is done (<code>if (done)</code>), we run <code>reader.cancel()</code> to cancel the stream, signalling that we don't need to use it any more.</p>

<pre class="brush: js">function fetchStream() {
  const reader = stream.getReader();
  let charsReceived = 0;

  // read() returns a promise that resolves
  // when a value has been received
  reader.read().then(function processText({ done, value }) {
    // Result objects contain two properties:
    // done  - true if the stream has already given you all its data.
    // value - some data. Always undefined when done is true.
    if (done) {
      console.log("Stream complete");
      reader.cancel();
      para.textContent = result;
      return;
    }

    // value for fetch streams is a Uint8Array
    charsReceived += value.length;
    const chunk = value;
    let listItem = document.createElement('li');
    listItem.textContent = 'Received ' + charsReceived + ' characters so far. Current chunk = ' + chunk;
    list2.appendChild(listItem);

    result += chunk;

    // Read some more, and call this function again
    return reader.read().then(processText);
  });
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Streams","#default-reader-cancel","cancel()")}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ReadableStreamDefaultReader.cancel")}}</p>
